﻿
// predefined data source and data IDs
// more: http://nvg.gpbeta.com/library/class_n_e_rv_gear_1_1_c_data_source.html
var DATA_URL = "http://nvg-data/";
var ID_ODATASOURCE = "00000001-4F00-6144-7461-536f75726365";
var ID_DATA_SYS    = "AE958FE5-785E-4C1D-9DAE-7FA7890870A5";
var ID_DATA_CPU    = "2F94BA5A-BAD6-472F-9C27-3AAE015C1917";
var ID_DATA_RAM    = "766A81E5-FC74-4C10-9020-27280857B1CB";
var ID_DATA_HDD    = "529DD40A-12A4-4196-AF7A-9A174943134B";
var ID_DATA_PWR    = "BA8D07C2-FA60-4BBB-84C4-5644FEA35388";
var ID_SYS_ACCOUNT = 7;
var ID_CPU_OVERALL = 0;
var ID_RAM_PHYSICS = 0;
var ID_HDD_FREESPC = 0;
var ID_PWR_LIFTIME = 2;

var UPDATE_INTERVAL = 1000; // 1s

var ID_LS_NOTE = "GPBeta.Demo.Note";

var g_isEditing = false;

function setTextItem(eid, ret)
{
    var text = "-";
    if (ret.result >= 0) {
        text = ret.data.value.toString();
        if (ret.data.unit != null)
            text += ret.data.unit;
    }
    document.getElementById(eid).innerHTML = text;
}

function setProgressItem(eid, ret)
{
    var text = "100%";
    if (ret.result >= 0) {
        var percentage = ret.data.value * 100 / (ret.data.maximum - ret.data.minimum);
        text = percentage + "%";
    }
    var element = document.getElementById(eid);
    element.innerHTML = text;
    element.style.width = text;
}

function updateItem(sid, did, vid, eid, isProgress)
{
    $.ajax({
        type: "get",
        dataType: "json",
        url: DATA_URL + sid + "/" + did + "/" + vid + "/query",
        success: function(ret){
            if (isProgress)
                setProgressItem(eid, ret);
            else
                setTextItem(eid, ret);
        }
    });
}

function refreshValues()
{
    // time
    var date = new Date();
    
    document.getElementById("date").innerHTML = 
        date.getFullYear() + "-" + (date.getMonth() + 1) + "-" + date.getDate() + " " + 
        date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds();
    
    updateItem(ID_ODATASOURCE, ID_DATA_CPU, ID_CPU_OVERALL, "cpu");
    updateItem(ID_ODATASOURCE, ID_DATA_SYS, ID_SYS_ACCOUNT, "user");
    updateItem(ID_ODATASOURCE, ID_DATA_PWR, ID_PWR_LIFTIME, "pwr");
    updateItem(ID_ODATASOURCE, ID_DATA_RAM, ID_RAM_PHYSICS, "ram", true);
    updateItem(ID_ODATASOURCE, ID_DATA_HDD, ID_HDD_FREESPC, "hdd", true);
}

function loadNote()
{
    return localStorage.getItem(ID_LS_NOTE);
}

function saveNote(note)
{
    localStorage.setItem(ID_LS_NOTE, note);
}

function updateNote(isEditing)
{
    var tag_l;
    var tag_r;
    
    var element = document.getElementById("note");
    
    if (isEditing) {
        // expand text area
        var h = element.scrollHeight - 10;
        tag_l = "<textarea style='height:" + h + "px;'>";
        tag_r = "</textarea>";
    } else {
        tag_l = "<pre>";
        tag_r = "</pre>";
    }
    
    element.innerHTML = tag_l + loadNote(ID_LS_NOTE) + tag_r;
}

function ToggleNote()
{
    g_isEditing = !g_isEditing;
    
    if (!g_isEditing)
        saveNote(document.getElementById("note").firstChild.value);
    
    updateNote(g_isEditing);
}

$(function() {
    // default note
    if (loadNote() == null)
        saveNote("Edit this note ->");
    // bind button event
    $("#btn").click(function(){ ToggleNote(); });
    
    updateNote();
    refreshValues();
    
    setInterval("refreshValues()", UPDATE_INTERVAL);
});
